
def loadInteractions(filename):
    f=open(filename)
    interactions={}
    f.readline() # header
    for row in f:
        data=row.split()
        if not interactions.has_key(data[0]):
            interactions[data[0]] = {}
        interactions[data[0]][data[1]] = 1
    f.close()
    return interactions

def selectInteractions(interactions, threshold):
    common_interactions={}
    for (key,value) in interactions.items():
        if len(value) >= threshold:
            common_interactions[key] = value
    return common_interactions    

def computeIntersection(elements1, elements2):
    inter=0
    for key in elements1.keys():
        if elements2.has_key(key):
            inter += 1
    return inter

def printIntersections(interactions):
    # header
    print("reg\t" + "\t".join(interactions.keys()))
    for (key1,elements1) in interactions.items():
        print(key1),
        for (key2,elements2) in interactions.items():
            if key1 == key2:
                inter=len(elements1)
            else:
                inter=computeIntersection(elements1, elements2)
            print("\t" + str(inter)),
        print

def computeInteractionOverlap(interactionfile,threshold):
    interactions = loadInteractions(interactionfile)
    common_interactions = selectInteractions(interactions, threshold)
    printIntersections(common_interactions)
